declare name 		"CageElectrophon";
declare version 	"1.0";
declare author 		"LP";
declare license 	"BSD";
declare copyright 	"(c)CIEREC 2016";

//-----------------------------------------------
// Cage Electrophon 
//-----------------------------------------------
import("stdfaust.lib");

gate = checkbox ("[1] gate");   
swfreq = hslider("[2]switchfreq (Hz) [style:radio{'84':0;'427':1 ; '1000':2 }]", 0, 0, 2, 1) : int;

vitesse = hslider("[3][acc:2 2 -10 0 10] speed", 33, 33, 78, 0.01) : si.smooth(0.999);	   
gain = hslider("[4] gain", 0.0, 0, 1, 0.01) : si.smooth(0.995);	      
pan = hslider("[5] pan", 0.5, 0, 1, 0.01);	   

freq = 84, 427, 1000 : select3(swfreq) ;
freq2 = freq * vitesse / 33 ;

envelop(gate, gain) = 0.2 * gate * gain ;

 // instr1  427 1000  // 84 196 Hz // instr 2 1000 2340

voice(gain, FF, gate) = (envelop(gate, gain) : *(os.osc (FF)));

tbar		= 0.1;					// attack/release time in seconds
gbar		= exp(-1/(ma.SR*tbar));	// corresponding gain factor
envbar		= abs : *(1-gbar) : + ~ *(gbar) : ba.linear2db;
meterL(x)	= attach(x, envbar(x) : hbargraph("levelL", -96, 10));	
meterR(x)	= attach(x, envbar(x) : hbargraph("levelR", -96, 10));	

process 	= voice(gain, freq2, gate)  <: *(1-pan), *(pan) : meterL , meterR;
