declare name 		"CageElectrophon";
declare version 	"1.0";
declare author 		"LP";
declare license 	"BSD";
declare copyright 	"(c)CIEREC 2016";

//-----------------------------------------------
// Send two sines on a stereo channel
//-----------------------------------------------
import("stdfaust.lib");



gain = hslider("[2] gain", 0.5, 0, 1, 0.01);	   
gate = checkbox ("[3] gate");   
swfreq = hslider("[1] switchfreq [style:radio{'1000':0;'2340':1}]", 0, 0, 1, 1) : int;

freq = 1000, 2340 : select2(swfreq);

envelop(gate, gain) = 0.2 * gate * gain : si.smooth(0.9995) ;

 // instr1  1000 427 // 84 196 Hz // instr 2 1000 2340

voice(gain, freq) = (envelop(gate, gain) : *(os.osc (freq)));


tbar		= 0.1;					// attack/release time in seconds
gbar		= exp(-1/(ma.SR*tbar));	// corresponding gain factor
envbar		= abs : *(1-gbar) : + ~ *(gbar) : ba.linear2db;
meter(x)	= attach(x, envbar(x) : hbargraph("[9]level", -96, 10));	



process 	= voice(gain, freq) : meter <: _,_;

