declare name 		"CageElectrophon";
declare version 	"1.0";
declare author 		"LP";
declare license 	"BSD";
declare copyright 	"(c)CIEREC 2016";

//-----------------------------------------------
// Send two sines on a stereo channel
//-----------------------------------------------
import("stdfaust.lib");



gate1 = checkbox ("[1] gate1");   
swfreq1 = hslider("[2] switchfreq1 [style:radio{'427':0;'1000':1}]", 0, 0, 1, 1) : int;

gate2 = checkbox ("[3] gate2");   
swfreq2 = hslider("[4] switchfreq2 [style:radio{'84':0;'196':1}]", 0, 0, 1, 1) : int;

gain = hslider("[5] gain", 0.5, 0, 1, 0.01);	   

freq1 = 1000, 2340 : select2(swfreq1): si.smooth(0.999) ;
freq2 = 64, 196 : select2(swfreq2): si.smooth(0.999) ;

envelop(gate, gain) = 0.2 * gate * gain ;

 // instr1  1000 427 // 84 196 Hz // instr 2 1000 2340

voice(gain, freq, gate) = (envelop(gate, gain) : *(os.osc (freq)));


tbar		= 0.1;					// attack/release time in seconds
gbar		= exp(-1/(ma.SR*tbar));	// corresponding gain factor
envbar		= abs : *(1-gbar) : + ~ *(gbar) : ba.linear2db;
meter(x)	= attach(x, envbar(x) : hbargraph("level", -96, 10));	



process 	= voice(gain, freq1, gate1) , voice(gain, freq2, gate2) : meter , meter :+<: _,_;

